package soln;

import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.TreeSet;
import java.util.Vector;

public class Labtest08_Sec01_Part5 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		/**
		 * [4 marks] Step 1: Create a code fragment that will create a set of
		 * consisting of elements that are taken from the file L08, in the same
		 * manner as in Part4. You need only to create and populate the set; you
		 * don't need to print anything out to System.
		 * 
		 * Modify the code so that a collection called "elementsNotAddedToSet"
		 * is kept that contains all courses that could not be added to MySet
		 * (for the reason that was the subject of Comprehension Question 2).
		 * 
		 * Choose an appropriate class for your collection - you can choose any
		 * class, but it must be chosen carefully so that it will implement the
		 * required functionality.
		 * 
		 * Choose an appropriate data type for the elements in your set. Here is
		 * some additional specification about what the elements should be:
		 * 
		 * In the code from Part4, you will have used the scanner to return the
		 * first two tokens from each line. The elements of the collection
		 * "elementsNotAddedToSet" should be the String that corresponds to the
		 * remaining tokens from the file line (e.g., the token that corresponds
		 * to the credit weight of the course and the course title).
		 * 
		 * Once mySet is created and populated with its elements, iterate over
		 * the elements of "elementsNotAddedToSet" and print them out to
		 * System.out, one per line. Preface the output with the line
		 * "Elements Not Added"
		 * 
		 * You will know whether your collection has been created properly if
		 * its size is equal to the difference between the number of lines in
		 * the input file and the number of elements in "mySet".
		 */

		File fileObject = new File("L08");
		Scanner input = new Scanner(fileObject);
		int numLines = 0;
		TreeSet<String> mySet = new TreeSet<String>();
		Vector<String> elementsNotAddedToSet = new Vector<String>();
		// notice that the collection "elementsNotAddedToSet" must be a list and
		// not a set because it needs to contain duplicate elements
		while (input.hasNext()) {
			numLines++;
			input.next();
			boolean isAddSuccessful = mySet.add(input.next());
			String entireLine = input.nextLine();
			if (!isAddSuccessful) {
				elementsNotAddedToSet.add(entireLine);
			}
		}

		System.out.println("Elements Not Added");
		for (String s : elementsNotAddedToSet) {
			System.out.println(s);
		}

		System.out.println(elementsNotAddedToSet.size());

		/**
		 * BONUS [2 marks]: modify the code above so that the elements of
		 * "elementsNotAddedToSet" consists of *only* the course title.
		 * 
		 * 
		 */

	}
}
