package soln;
import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.TreeSet;
import java.util.Vector;

public class Labtest08_Sec01_Part4 {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		/**
		 * [5 marks] Step 1: Create a code fragment that will create a set
		 * called "mySet". The set should contain elements that are taken from
		 * the file L08 in the following manner:
		 * 
		 * The elements in the set should correspond to the second token of each
		 * line of the file (which are the course numbers of the various courses
		 * offered by the department of History at York). You may assume that
		 * each line of the input file contains at least two tokens. Don't
		 * forget that after you retrieve the first two tokens from the scanner
		 * object, you need to advance the scanner position to the start of the
		 * next line.
		 * 
		 * Set up a variable called numLines that will keep track the total
		 * number of lines that is returned by the scanner.
		 * 
		 * Choose an appropriate data type for the elements in your set. Choose
		 * an appropriate class for your set - you can choose any class, but it
		 * must be a set and not a list. You may wish to consult L14.java.
		 * 
		 * Once the collection is created and populated with its elements, print
		 * out to System.out the total number of lines returned by the Scanner
		 * object. You should prefix the output with the string
		 * "Total number of lines read in: "
		 * 
		 */
		File fileObject = new File("L08");
		Scanner input = new Scanner(fileObject);
		int numLines = 0;
		TreeSet<String> mySet = new TreeSet<String>();
		while (input.hasNext()) {
			numLines++;
			input.next();
			mySet.add(input.next());
			input.nextLine();
		}
		System.out.println("Total number of lines read in: " + numLines);

		/**
		 * [2 marks] Step 2: Print to System.out the total size of the
		 * collection. Determine the size of the collection from the collection
		 * object itself and not from the numLines variable from the code
		 * fragment from Step 1.
		 * 
		 * You should prefix the output with the string
		 * "Total number of elements in set: "
		 */
		System.out.println("Total number of elements in set: " + mySet.size());

		/**
		 * [2 marks] Step 2: Iterate over the collection and print out each
		 * element.
		 */
		for (String s : mySet) {
			System.out.println(s);
		}

		/**
		 * 
		 * NOW ANSWER COMPREHENSION QUESTION 2.
		 * 
		 */

	}
}
